// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'ngCordova'])

.run(function($ionicPlatform,$ionicPopup,$rootScope,$window, $state) {

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    //network connection
    if(window.Connection) {
      if(navigator.connection.type == Connection.NONE) {
        $ionicPopup.confirm({
          title: 'No Internet Connection',
          content: 'Sorry, no Internet connectivity detected. Please reconnect and try again.'
        })
        .then(function(result) {
          if(!result) {
            ionic.Platform.exitApp();
          }
        });
      }
    }

          // Disable BACK button on home
  $ionicPlatform.registerBackButtonAction(function(event) {
    if (true) { // your check here
      $ionicPopup.confirm({
        title: 'App Exit',
        template: 'Are you sure want to exit?'
      }).then(function(res) {
        if (res) {
          ionic.Platform.exitApp();
        }
      })
    }
    else
  $ionicHistory.goBack();
    }, 100);

  });

    setTimeout(function() {
        // navigator.splashscreen.hide();
    }, 300);

})

.run(['$rootScope', '$state',
    function ($rootScope, $state) {
        $rootScope.$state = $state;
    }
])

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider
    .state('login', {
    url: '/login',    
    templateUrl: 'templates/login.html'    
  })
    // .state('firstpage',{
    //   url:'/firstpage',
    //   templateUrl :'templates/firstPage.html'
    // })
    
  
  // setup an abstract state for the tabs directive
    .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html',
    controller: 'tabsCtrl'
  })

  // Each tab has its own nav history stack:

  .state('tab.jobs', {
    url: '/jobs',
    views: {
      'tab-jobs': {
        templateUrl: 'templates/tab-myjobs.html',
        controller:'jobcontroller_lists'
        // controller: 'DashCtrl'
      }
    }
  })

   .state('tab.job_detail', {
    url: '/jobs/:jobId',
    // url: '/jobs/jobdetail',
    views: {
      'tab-jobs': {
        templateUrl: 'templates/job_detail.html',
        controller: 'jobDetailcontroller_lists'
      }
    }
  })
   .state('tab.pending', {
    url: '/pending',
    views: {
      'tab-pending': {
        templateUrl: 'templates/tab-pending.html',
        controller:'pending_ctrl'
      }
    }
  })

.state('tab.complete', {
    url: '/complete',
    views: {
      'tab-complete': {
        templateUrl: 'templates/tab-complete.html',
         controller: 'complete_ctrl'
      }
    }
  })
  .state('tab.inspection', {
      url: '/inspection',
      views: {
        'tab-jobs': {
          templateUrl: 'templates/inpectorjoblists.html',
          controller:'inpector_ctrl'
          // controller: 'ChatsCtrl'
        }
      }
    })
    .state('tab.ins_detail', {
    url: '/inspection/:ScheduleID',
    // url: '/jobs/jobdetail',
    views: {
      'tab-jobs': {
        templateUrl: 'templates/inspector_detail.html',

        controller: 'inspectioncontroller_lists'
      }
    }
  })
    .state('tab.ins_pending', {
    url: '/inspectionpending',
    // url: '/jobs/jobdetail',
    views: {
      'tab-pending': {
        templateUrl: 'templates/inspectionpendingjobs.html',

        controller: 'inspectionpending_ctrl'
      }
    }
  })
    .state('tab.ins_complete', {
    url: '/inspectioncomplete',
    // url: '/jobs/jobdetail',
    views: {
      'tab-complete': {
        templateUrl: 'templates/inspection_complete.html',

        controller: 'inspectioncompleted_ctrl'
      }
    }
  })
    //     .state('tab.inspectorjobs', {
    //   url: '/inspectorjobs',
    //   views: {
        
    //       templateUrl: 'templates/inpectorjoblists.html',
    //       // controller: 'ChatDetailCtrl'
        
    //   }
    // })

  .state('tab.account', {
    url: '/account',
    views: {
      'tab-account': {
        templateUrl: 'templates/tab-account.html',
        // controller: 'AccountCtrl'
      }
    }
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/login');
})
// .config(function($ionicConfigProvider) {
//     $ionicConfigProvider.backButton.text('').icon('ion-ios7-arrow-left');
//     $ionicConfigProvider.backButton.previousTitleText(false);
// })
.config(['$ionicConfigProvider', function($ionicConfigProvider) {

    $ionicConfigProvider.tabs.position('bottom'); // other values: top

}]);
// .run(function($ionicPlatform, $rootScope, $timeout, $ionicHistory,$state) {

//     $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
//       $rootScope.previousState = fromState.name;
//       console.log($rootScope.previousState);
//       // console.log('stateChangeSuccess');
//       //   console.log('State change from: ' + fromState.name + ' to: ' + toState.name);

//     });
//     });
